// clues.js

let cluebox = refObject;

class Cluer
{ constructor(cluebox)
  { this.cluebox = cluebox;
    this.clues = [];
    this.input = null;
  }
  new_clue()
  {   if(this.input||this.clues.length>8){return;}
      let clue = new Clue(this);
      this.clues.push(clue);
      this.input = clue.textbox;
  }
  reset()
  { this.clues = [];
    this.input = null;
  }
}

let cluer = cluebox.cluer = new Cluer(cluebox);

class Clue
{ constructor(cluer)
  { let x1 = 12;  let dx = 3;
    let cluetext = "Clue — ∞";
    this.cluer = cluer;
    let clue_count = this.cluer.clues.length;
    this.textbox = new TextBox().setText(cluetext);
    this.textboxui = new UIElement();
    this.textboxui.position = new Vector(x1-dx*clue_count, 0, 0.1);
    this.textboxui.widget = this.textbox;
    this.cluer.cluebox.attachUI(this.textboxui);
    this.button = new Button().setText("✓");
    this.button.onClicked.add((button, player)=>{this.convert_textbox_to_text();});
    this.buttonui = new UIElement();
    this.buttonui.position = new Vector(x1-dx*clue_count, 9, 0.1);
    this.buttonui.scale = 0.75;
    this.buttonui.widget = this.button;
    this.cluer.cluebox.attachUI(this.buttonui);
  }
  convert_textbox_to_text()
  {   this.text = new Text().setText(this.textbox.getText());
      this.textui = new UIElement();
      this.textui.position = this.textboxui.position;
      this.textui.widget = this.text;
      this.cluer.cluebox.removeUI(this.cluer.clues.length); // remove confirm button
      this.cluer.cluebox.setUI(this.cluer.clues.length, this.textui); // convert
      this.cluer.input = null;
  }

}


function place_newclue_button()
{   let button = new Button().setText("New Clue");
    button.onClicked.add(cluer.new_clue.bind(cluer));
    let ui = new UIElement();
    ui.position = new Vector(-15, 0, 0.1);
    ui.widget = button;
    refObject.attachUI(ui);
    refObject.newcluebutton = button;
};
place_newclue_button();

refObject.reset_clues = function()
{   while(this.getAttachedUIs().length>1) { this.removeUI(1); }
    this.cluer.reset();
};
