// words.js

function place_words_cards(cards, x0=0)
{ let y0 = 0; let z = 88;
  let dx = 6; let dy = 9;
  let words_positions =
  [ new Vector(x0+2*dx, y0-2*dy, z), new Vector(x0+2*dx, y0-1*dy, z), new Vector(x0+2*dx, y0 , z), new Vector(x0+2*dx, y0+1*dy, z), new Vector(x0+2*dx, y0+2*dy, z),
    new Vector(x0+1*dx, y0-2*dy, z), new Vector(x0+1*dx, y0-1*dy, z), new Vector(x0+1*dx, y0 , z), new Vector(x0+1*dx, y0+1*dy, z), new Vector(x0+1*dx, y0+2*dy, z),
    new Vector(x0-0*dx, y0-2*dy, z), new Vector(x0-0*dx, y0-1*dy, z), new Vector(x0-0*dx, y0 , z), new Vector(x0-0*dx, y0+1*dy, z), new Vector(x0-0*dx, y0+2*dy, z),
    new Vector(x0-1*dx, y0-2*dy, z), new Vector(x0-1*dx, y0-1*dy, z), new Vector(x0-1*dx, y0 , z), new Vector(x0-1*dx, y0+1*dy, z), new Vector(x0-1*dx, y0+2*dy, z),
    new Vector(x0-2*dx, y0-2*dy, z), new Vector(x0-2*dx, y0-1*dy, z), new Vector(x0-2*dx, y0 , z), new Vector(x0-2*dx, y0+1*dy, z), new Vector(x0-2*dx, y0+2*dy, z),
  ];
  for(let i=0; i<25; i++) { cards[i].setPosition(words_positions[i],1); }
}

function clear_words_cards(discard)
{ let words_cards = world.boxOverlap(new Vector(0, 0, 87), new Vector(15, 20, 1)).filter(object=>object.getTemplateName().includes("words"));
  words_cards.forEach(card=>discard.addCards(card, false, 0, true));
}

module.exports = { place_words_cards, clear_words_cards };
